import { ReactElement, ElementType } from 'react';
import { FormControlProps } from 'react-bootstrap/FormControl';
import { ReplaceProps, BsPrefixProps } from 'react-bootstrap/helpers';
import { IFormFieldProps as ICoreFormFieldProps, IFormFieldValue, IRenderFormField } from '@reactionable/core';
export declare type IFormFieldProps<FieldElement extends ElementType, Value extends IFormFieldValue> = Omit<ICoreFormFieldProps<FieldElementProps<FieldElement>, Value>, 'children'> & {
    label?: ReactElement;
    children?: IRenderFormField<FieldElementProps<FieldElement>, Value>;
};
declare type FieldElementProps<FieldElement extends ElementType> = ReplaceProps<FieldElement, BsPrefixProps<FieldElement> & FormControlProps>;
export declare function FormField<FieldElement extends ElementType = 'input', Value extends IFormFieldValue = string>({ label, children, ...props }: IFormFieldProps<FieldElement, Value>): JSX.Element;
export {};
